import 'dart:async';

import 'package:cloud_firestore/cloud_firestore.dart';

import '../../abg_utils.dart';

class UserData {
  final String id;
  String name;
  final String email;
  final String role;
  String logoServerPath;
  final bool providerApp;
  String fcb;

  int unread = 0;
  int all = 0;
  String lastMessage = "";
  DateTime? lastMessageTime;
  List<AddressData> address;

  // ignore: cancel_subscriptions
  StreamSubscription<DocumentSnapshot>? listen;

  UserData({this.id = "", this.name = "", this.role  = "",
    this.logoServerPath = "", this.providerApp = false, this.email = "", this.fcb = "", required this.address});

  Map<String, dynamic> toJson() => {
    'name': name,
    'role': role,
    'email': email,
    'logoServerPath': logoServerPath,
    'providerApp': providerApp,
    'FCB': fcb,
    'address': address.map((i) => i.toJson()).toList(),
  };

  factory UserData.fromJson(String id, Map<String, dynamic> data){
    List<AddressData> _address = [];
    if (data['address'] != null)
      for (var element in List.from(data['address'])) {
        _address.add(AddressData.fromJson(element));
      }
    return UserData(
      id: id,
      name: (data["name"] != null) ? data["name"] : "",
      email: (data["email"] != null) ? data["email"] : "",
      role: (data["role"] != null) ? data["role"] : "",
      fcb: (data["FCB"] != null) ? data["FCB"] : "",
      logoServerPath: (data["logoServerPath"] != null) ? data["logoServerPath"] : "",
      providerApp: (data["providerApp"] != null) ? data["providerApp"] : false,
      address: _address,
    );
  }

  int compareToAll(UserData b){
    return b.all.compareTo(all);
  }
  int compareToUnread(UserData b){
    return b.unread.compareTo(unread);
  }
}
